
LIBRARY ieee;
USE ieee.std_logic_1164.all;
-- USE ieee.std_logic_unsigned.all;

entity EightBitCounter is
	port
	(
		Enable, Clear, Clock	 : in std_logic;
		Q : out std_logic_vector(7 downto 0)
	);
end;


architecture behav of EightBitCounter is
   signal count : std_logic_vector(7 downto 0);
	signal En    : std_logic_vector(7 downto 0);
begin

   En(0) <= Enable;

   T1: entity work.T_FF(behav)
	port map (Enable, Clock, Clear, count(0));
	
	En(1) <= En(0) AND count(0);
	
   T2: entity work.T_FF(behav)
	port map (En(1), Clock,  Clear, count(1));	
	
	En(2) <= En(1) AND count(1);
	
   T3: entity work.T_FF(behav)
	port map (En(2), Clock,  Clear, count(2));
	
	En(3) <= En(2) AND count(2);
	
   T4: entity work.T_FF(behav)
	port map (En(3), Clock,  Clear, count(3));

	En(4) <= En(3) AND count(3);
		
   T5: entity work.T_FF(behav)
	port map (En(4), Clock,  Clear, count(4));
	
	En(5) <= En(4) AND count(4);
	
   T6: entity work.T_FF(behav)
	port map (En(5), Clock,  Clear, count(5));		

	En(6) <= En(5) AND count(5);
	
   T7: entity work.T_FF(behav)
	port map (En(6), Clock,  Clear, count(6));

	En(7) <= En(6) AND count(6);
	
   T8: entity work.T_FF(behav)
	port map (En(7), Clock,  Clear, count(7));	
	
   Q <= count;	
	    	
	
end behav;