
LIBRARY ieee;
USE ieee.std_logic_1164.all;
-- USE ieee.std_logic_unsigned.all;

entity FourBitCounter is
	port
	(
		Enable, Clear, Clock	 : in std_logic;
		Q : out std_logic_vector(3 downto 0)
	);
end;


architecture behav of FourBitCounter is
   signal count : std_logic_vector(3 downto 0);
	signal En    : std_logic_vector(3 downto 0);
begin

   En(0) <= Enable AND count(0);

   T1: entity work.T_FF(behav)
	port map (Enable, Clock, Clear, count(0));
	
	En(1) <= En(0) AND count(0);
	
   T2: entity work.T_FF(behav)
	port map (En(1), Clock,  Clear, count(1));	
	
	En(2) <= En(1) AND count(1);
	
   T3: entity work.T_FF(behav)
	port map (En(2), Clock,  Clear, count(2));
	
	En(3) <= En(2) AND count(2);
	
   T4: entity work.T_FF(behav)
	port map (En(3), Clock,  Clear, count(3));
	
   Q <= count;	
	    	
	
end behav;