LIBRARY ieee;
USE ieee.std_logic_1164.all;
-- USE ieee.std_logic_unsigned.all;

--entity part1 is
--	port
--	(
--		SW	 : in std_logic_vector(1 downto 0);
--		Key : in std_logic_vector(0 downto 0);
--		Hex0 : out std_logic_vector(0 to 6);
--		Hex1 : out std_logic_vector(0 to 6);		
--	);
--end;

entity part1 is
	port
	(
		Enable, Clear, Clock	 : in std_logic;
		Q : out std_logic
	);
end;


architecture behav of part1 is
   signal count : std_logic_vector(7 downto 0);
	signal T : std_logic_vector(2 to 8);
begin


   T1: entity work.T_FF(behav)
	port map (Enable, Clock, Clear, count(0));
	
	T(2) <= Enable AND count(0);
	
   T2: entity work.T_FF(behav)
	port map (T(2), Clock,  Clear, count(1));	
	
	T(3) <= Enable AND count(1);	
	
   T3: entity work.T_FF(behav)
	port map (T(3), Clock,  Clear, count(2));
	
	T(4) <= Enable AND count(2);
	
   T4: entity work.T_FF(behav)
	port map (T(4), Clock,  Clear, count(3));

	T(5) <= Enable AND count(3);
		
   T5: entity work.T_FF(behav)
	port map (T(5), Clock,  Clear, count(4));
	
	T(6) <= Enable AND count(4);	
	
   T6: entity work.T_FF(behav)
	port map (T(6), Clock,  Clear, count(5));		

	T(7) <= Enable AND count(5);
	
   T7: entity work.T_FF(behav)
	port map (T(7), Clock,  Clear, count(6));

	T(8) <= Enable AND count(6);
	
   T8: entity work.T_FF(behav)
	port map (T(8), Clock,  Clear, count(7));	
	
   Q <= count(7);	
	    	
	
end behav;