library ieee;
use ieee.std_logic_1164.all;


entity testbench is
end testbench;

architecture tb of testbench is
	constant T_clk : time := 20 ns;
	signal en_tb, clk_tb, cl_tb : std_logic;  -- inputs 
	signal q_tb : std_logic;  -- outputs
begin
	-- connecting testbench signals
	UUT : entity work.part1 port map ( Enable => en_tb, Clear => cl_tb, Clock => clk_tb, Q => q_tb );


	-- continuous clock
	
	process
	begin
	clk_tb <= '1';
	wait for T_clk/2;
	clk_tb <= '0';
	wait for T_clk/2;
	end process;

	-- signals
	process
	begin
	cl_tb <= '0'; 
	en_tb <= '0';
	wait for 30 ns;
	cl_tb <= '1';
	en_tb <= '1';
	wait for 100 ns;
	en_tb <= '0';
	wait for 60 ns;
	en_tb <= '1';
	wait for 60 ns;
	cl_tb <= '0';
	wait for 60 ns;
	end process;
end tb ;