LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity mux_2bit_6to1 is
	port
	(
	   sel : in std_logic_vector(2 downto 0);
	   r,s,t,u,v,w : in std_logic_vector(1 downto 0);
		y  : out std_logic_vector(1 downto 0)
	);
end;



architecture behav of mux_2bit_6to1 is
begin
    
	with sel select
	y <= r when "000",
	     s when "001",
		  t when "010",
	     u when "011",
		  v when "100",
		  w when "101",
		  r when others ;
end behav;