LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity T_FF is
	port
	(
		T, ClK, Clear : in std_logic;
		Q: out std_logic
	);
end;


architecture behav of T_FF is
begin
  process (Clk) is
     variable Qint : std_ulogic := '0';
  begin
	  if rising_edge(clk) then
		  if Clear='0' then
				Qint := '0';
		  elsif T='1' then
				Qint := not Qint;
		  end if;
		end if;
		Q <= Qint;
	end process;
	
end architecture;
