
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

entity SixteenBitCounter is
	port
	(
		Enable, Clear, Clock	 : in std_logic;
		Q : buffer std_logic_vector(15 downto 0)
	);
end;


--architecture behav of EightBitCounter is
--begin
--
--  count: process(Clock) is
--     variable count : std_logic_vector(7 downto 0) := x"00";
--  begin
--		if rising_edge(Clock) then
--			if Clear='0' then
--			    count := x"00";
--		   elsif Enable='1' then
--			    count := count+'1';
--		   end if;
--		end if;
--		Q<=count;
--		
--	end process;
--	  
--end behav;


architecture behav of SixteenBitCounter is
begin

  count: process(Clock) is
  begin
		if rising_edge(Clock) then
			if Clear='0' then
			    Q <= x"0000";
		   elsif Enable='1' then
			    Q <= Q +'1';
		   end if;
		end if;
	end process;
	  
end behav;