LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

entity part3 is
	port
	(
		CLOCK_50	 : in std_logic;
		Hex0 : out std_logic_vector(0 to 6)
	);
end;


architecture behav of part3 is
   constant max_count : std_logic_vector(25 downto 0) := (others =>'1');
   signal count1 : std_logic_vector(25 downto 0) := (others =>'0');
	signal count2 : std_logic_vector(3 downto 0) := (others =>'0');
	signal Zero : Boolean;
begin

FirstCounter:   
   process (CLOCK_50) is
	begin
		if rising_edge(CLOCK_50) then
		    count1 <= count1 + 1;
	   end if;
   end process;
	
	Zero <= count1 = max_count;
	
SecondCounter:	
   process (CLOCK_50) is
	begin
		if rising_edge(CLOCK_50) then
		    if Zero then
			    if count2="1001" then
				     count2<="0000";
				 else 
		          count2 <= count2 + 1;
			    end if;
			  end if;	 
	   end if;
   end process;
	
   H0: entity work.DisplayDigit(behav)
	port map (count2, HEX0);
	
	
end architecture;
	
	
	
